/*  * * * * * * * * * * * * * * * * * * * * * * * * * * * *

    Disclaimer:

    I do not foresee any risk in running this script but
    you may run this file "ONLY" at your own risk. 

    * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

File Name   : ColorPicker_GENIE.ahk 		Version : 1.00 Beta


Main Title  : AutoHotkey Helper App
Sub Title   : ColorPicker GENIE
Posted @    : http://www.autohotkey.com/forum/viewtopic.php?p=57968#57968


Description : "ColorPicker GENIE" is a Clipboard monitoring utility that waits until 
              the Clipboard contains a Valid Color Code and when finds one - pops up 
              the ColorPicker Utility.

              Amidst AHK Scripting, one may find a requirement to pick a suitable color 
              for a GUI background, Text Control etc.

              With "ColorPicker GENIE" running in the System Tray, life will be easier.          
              
              To Insert a Color Code : Press Control+Win+Insert ... and the
              ColorPicker Pops up. Select a Color and Press okay ... you're done.
 
              To Replace/Preview a Color code :
              Double Click on the Color Code - Right Click - Copy ... and the 
              ColorPicker Pops up. Select a Color and Press okay ... you're done.

              Supported prefixes for Color Codes are "c" and "#"

              For eg. HEX code for "White color" will be detected when put in Clipboard as

              FFFFFF
              cFFFFFF
              #FFFFFF

              When AHK Scripting - "Double clicking" is enough for selecting the Color code. 
              The leading or trailing spaces will be taken care of. The GENIE pastes back the 
              edited Color code with exact number of leading/trailing spaces as found in clipboard.

              Double clicking the "Tray Icon" will Pause/Resume the script. However manual insertion 
              is always possible with hotkey Control+WIN+Insert.

              Though written as a "Helper App" for/in AutoHotkey, this utility will be helpful for 
              editing Color codes contained in HTML.


              This Script requires ColorPicker.ahk for functioning.
              
Author      : A.N.Suresh Kumar aka "Goyyah"
Email       : arian.suresh@gmail.com

Created     : 2006-03-22
Modified    : 2006-04-27
Version     : 1.00 Beta

Scripted in : AutoHotkey Version 1.0.43.04 , www.autohotkey.com 

*/

#SingleInstance, Force
#Persistent
AutoTrim, On 
SetKeyDelay -1,-1
ClipboardOption=Disabled
WindowTitle = ColorPicker Genie

Menu, Tray, NoStandard
Menu, Tray, UseErrorLevel, On
Menu, Tray, Icon, CPG1.ico,, 1
Menu, Tray, Add, &Insert Color Code`t[Ctrl+Win+Insert], InsertColorCode
Menu, Tray, Add, &Genie`t[Ctrl+Win+Break], Pausee
Menu, Tray, Add,
Menu, Tray, Add, View &Colors.htm, Colors.HTM
Menu, Tray, Add,
Menu, Tray, Add, &Reload Script, Reloadd
Menu, Tray, Add, &Exit %WindowTitle%, Exitt
Menu, Tray, Tip, %WindowTitle% - Running
Menu, Tray, Default, &Genie`t[Ctrl+Win+Break]
Menu, Tray, Check, &Genie`t[Ctrl+Win+Break]

SetTimer CheckClipBoard,10
Return

^#CtrlBreak::GoSub, Pausee
^#Insert::GoSub, InsertColorCode

CheckClipBoard:

  SetTimer CheckClipBoard,OFF

  Winget,Win_ID,ID,A
  OClip:=Clipboard
  ClipText=%OClip%


  If StrLen(Cliptext)=6
    {
      ValidColor:=CheckHexC(ClipText)
      
      If ValidColor
        {
          HexC:=ColorPicker(ClipText,WindowTitle " - Insert Mode (Auto)")
          Clipboard:=
         
          If HexC <>
           {
             WinActivate, ahk_id %Win_ID%
             StringReplace, OClip, OClip, % Cliptext, % HexC
             SendRaw, % OClip
           }
        }
    }



  If StrLen(Cliptext)=7
    {
      StringLeft, FChar, Cliptext, 1, 1

      If (FChar=# or FChar=c)
        {
          StringTrimLeft, ClipText, ClipText, 1
          ValidColor:=CheckHexC(ClipText)

          If ValidColor
            {
              HexC:=ColorPicker(ClipText,WindowTitle " - Insert Mode (Auto)")
              Clipboard:=

                If HexC <>
                  {
                    WinActivate, ahk_id %Win_ID%
                    StringReplace, OClip, OClip, % Cliptext, % HexC
                    SendRaw, % OClip
                  }
            }
        }
    }

  If A_IconTip = %WindowTitle% - Running
     SetTimer, CheckClipBoard, 250

Return

InsertColorCode:

    Winget,Win_ID,ID,A

    HexC_IM:=ColorPicker(Clipboard,WindowTitle " - Insert Mode")
   
    If HexC_IM <>
     {
       WinActivate, ahk_id %Win_ID%
       SendRaw, % HexC_IM
     }
Return

Pausee:
  If A_IconTip=%WindowTitle% - Running
    {
      Menu, Tray, Tip, %WindowTitle% - Dormant
      Menu, Tray, UnCheck, &Genie`t[Ctrl+Win+Break]
      Menu, Tray, Icon, CPG0.ico,, 1
      SetTimer CheckClipBoard, OFF
    }
  Else
    {
      Menu, Tray, Tip, %WindowTitle% - Running
      Menu, Tray, Check, &Genie`t[Ctrl+Win+Break]
      Menu, Tray, Icon, CPG1.ico,, 1
      SetTimer CheckClipBoard,10
    }

Return


Reloadd:
 Reload
Return

Exitt:
 ExitApp
Return

Colors.HTM:
Run, Colors.HTM
Return

#Include ColorPicker.AHK