//----------------------------------------------------------
//
//  GRAND LARCENY  1.0
//  A freeroam gamemode for SA-MP 0.3
//
//----------------------------------------------------------

#include <a_samp>
#include <core>
#include <float>
#include "../include/gl_common.inc"
#include "../include/gl_spawns.inc"

#pragma tabsize 0

//----------------------------------------------------------
#define DIALOG_0 (0)
#define DIALOG_1 (1)
#define DIALOG_2 (2)
#define DIALOG_3 (3)
#define COLOR_WHITE 		0xFFFFFFFF
#define COLOR_NORMAL_PLAYER 0xFF4444FF
#define COLOR_LIGHTRED 0xFF6347AA
#define CITY_LOS_SANTOS 	0
#define CITY_SAN_FIERRO 	1
#define CITY_LAS_VENTURAS 	2
#define COLOR_YELLOW 0xFFFF00AA
new total_vehicles_from_files=0;

// Class selection globals
new gPlayerCitySelection[MAX_PLAYERS];
new gPlayerHasCitySelected[MAX_PLAYERS];
new gPlayerLastCitySelectionTick[MAX_PLAYERS];

new Text:txtClassSelHelper;
new Text:txtLosSantos;
new Text:txtSanFierro;
new Text:txtLasVenturas;
new szallit[MAX_PLAYERS];
forward IsATruck(carid);
forward IsAPlato(carid);
//----------------------------------------------------------

main()
{
	print("\n---------------------------------------");
	print("Running Grand Larceny - by the SA-MP team\n");
	print("---------------------------------------\n");
}




public IsAPlato(carid)
{
	new model = GetVehicleModel(carid);
	new jarmuvek[4] = {435, 450, 591, 584};
	for(new u = 0; u < sizeof(jarmuvek); u++)
	{
		if(jarmuvek[u] == model)
			return 1;
	}
	return 0;
}




stock IsVehicleConnected(vehicleid) //By Sacky (edited by Gabriel "Larcius" Cordes)
{
	new Float:x1,Float:y1,Float:z1;
	GetVehiclePos(vehicleid,x1,y1,z1);
	if(x1==0.0 && y1==0.0 && z1==0.0)
	{
		return 0;
	}
	return 1;
}

stock GetParam(const string[], number)
{
	new kezdes=0, spacevolt=0, szavak=-1, eredmeny[MAX_PLAYER_NAME] = "-1";

	new utolsobetu = strlen(string) - 1;

	for(new x = 0; x < strlen(string); x++)
	{
		if(string[x] <= ' ' || x == utolsobetu)
		{
			if(!spacevolt)
			{
				szavak++;
				if(szavak == number)
				{
					if(x == utolsobetu && string[x] > ' ')
						strmid(eredmeny, string, kezdes, x+1);
					else
						strmid(eredmeny, string, kezdes, x);
				}
			}
			else if(x == utolsobetu)
			{
				if(string[x] > ' ')
				{
					szavak++;
					if(szavak == number)
					{
						strmid(eredmeny, string, x, x+1);
					}
				}
			}

			spacevolt = 1;
		}
		else
		{
			if(spacevolt == 1)
			{
				kezdes = x;
			}
			spacevolt = 0;
		}
	}
	return eredmeny;
}

stock Parameterek(string[])
{
	new volt, szam;
	for(new x = 0; x < strlen(string); x++)
	{
		if(string[x] <= ' ')
		{
			volt = 1;
		}
		else
		{
			if(volt == 1) szam++;
			volt = 0;
		}
	}

	return szam;
}

//----------------------------------------------------------

public IsATruck(carid)
{
	new model = GetVehicleModel(carid);
	new jarmuvek[10] = {403, 414, 433, 456, 498, 499, 514, 515, 573, 609};
	for(new u = 0; u < sizeof(jarmuvek); u++)
	{
		if(jarmuvek[u] == model)
			return 1;
	}
	return 0;
}



public OnPlayerConnect(playerid)
{
	GameTextForPlayer(playerid,"~w~Grand Larceny",3000,4);
  	SendClientMessage(playerid,COLOR_WHITE,"Welcome to {88AA88}G{FFFFFF}rand {88AA88}L{FFFFFF}arceny");
  	
  	// class selection init vars
  	gPlayerCitySelection[playerid] = -1;
	gPlayerHasCitySelected[playerid] = 0;
	gPlayerLastCitySelectionTick[playerid] = GetTickCount();

	//SetPlayerColor(playerid,COLOR_NORMAL_PLAYER);
	
	return 1;
}

//----------------------------------------------------------

public OnPlayerSpawn(playerid)
{
	if(IsPlayerNPC(playerid)) return 1;
	
	new randSpawn = 0;
	
	SetPlayerInterior(playerid,0);
	TogglePlayerClock(playerid,0);
 	ResetPlayerMoney(playerid);
	GivePlayerMoney(playerid, 60000);
	
	// if they ever return to class selection make them city
	// select again first
	gPlayerHasCitySelected[playerid] = 0;

	if(CITY_LOS_SANTOS == gPlayerCitySelection[playerid]) {
 	    randSpawn = random(sizeof(gRandomSpawns_LosSantos));
 	    SetPlayerPos(playerid,
		 gRandomSpawns_LosSantos[randSpawn][0],
		 gRandomSpawns_LosSantos[randSpawn][1],
		 gRandomSpawns_LosSantos[randSpawn][2]);
		SetPlayerFacingAngle(playerid,gRandomSpawns_LosSantos[randSpawn][3]);
	}
	else if(CITY_SAN_FIERRO == gPlayerCitySelection[playerid]) {
 	    randSpawn = random(sizeof(gRandomSpawns_SanFierro));
 	    SetPlayerPos(playerid,
		 gRandomSpawns_SanFierro[randSpawn][0],
		 gRandomSpawns_SanFierro[randSpawn][1],
		 gRandomSpawns_SanFierro[randSpawn][2]);
		SetPlayerFacingAngle(playerid,gRandomSpawns_SanFierro[randSpawn][3]);
	}
	

	//SetPlayerColor(playerid,COLOR_NORMAL_PLAYER);
	
	SetPlayerSkillLevel(playerid,WEAPONSKILL_PISTOL,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_PISTOL_SILENCED,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_DESERT_EAGLE,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_SHOTGUN,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_SAWNOFF_SHOTGUN,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_SPAS12_SHOTGUN,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_MICRO_UZI,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_MP5,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_AK47,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_M4,200);
    SetPlayerSkillLevel(playerid,WEAPONSKILL_SNIPERRIFLE,200);
    
    GivePlayerWeapon(playerid,WEAPON_M4,100);
	//GivePlayerWeapon(playerid,WEAPON_MP5,100);
	//TogglePlayerClock(playerid, 1);

	return 1;
}

//----------------------------------------------------------




public OnPlayerCommandText(playerid, cmdtext[])

{

	new params = Parameterek(cmdtext);
	new param[10][32];

	if(params > 0)
	{
		new params_szamlalo = 1;
		while(params_szamlalo <= params && params_szamlalo < sizeof(param))
		{
			param[params_szamlalo] = GetParam(cmdtext, params_szamlalo);
			params_szamlalo++;
		}
	}


        if (strcmp("/help", cmdtext, true, 4) == 0)
        {
                SendClientMessage(playerid, 0xAA3333AA, "Bertad a help parancsot!");
                return 1;
        }


       if(!strcmp("/teszt", cmdtext, true))
			{
       ShowPlayerDialog(playerid, DIALOG_1, DIALOG_STYLE_LIST, "Szia! Mi a DM?","Egy zlet\nOk nlkli ls amit tilos csinlni.\nOk nlkli ls amit szabad","Kivlaszt","Mgse");
				return 1;
			}
  		  if(!strcmp(cmdtext, "/lekapcsol", true))
			{
                if(GetPlayerState(playerid) != PLAYER_STATE_DRIVER || GetVehicleTrailer(GetPlayerVehicleID(playerid)) == 0)
			{ SendClientMessage(playerid, 0x375FFFFF, "Nem vagy jrmben, vagy a jrmhz nincs trailer kapcsolva"); } else {


				DetachTrailerFromVehicle(GetPlayerVehicleID(playerid));
				SendClientMessage(playerid, 0x375FFFFF, "A ptkocsit lekapcsoltad");
				return 1;}
			}
		if(!strcmp("/veh", cmdtext, true))
			{
			    ShowPlayerDialog(playerid, DIALOG_3, DIALOG_STYLE_LIST, "Szia! Vlassz egy jrmvet!","Kamion\npt kocsi\npt kocsi","Kivlaszt","Mgse");
				return 1;
			}
		if(!strcmp("/bnya", cmdtext, true))
		    {
     		SetPlayerPos(playerid,304.7050,878.9153,21.0331);
     		return 1;
			}
		if(!strcmp("/sf", cmdtext, true))
		    {
     			SetPlayerPos(playerid,-1893.4498,-1701.9182,22.3645);
     			return 1;
			}
	
		if(!strcmp("/kam", cmdtext, true))
		    {
     			SetPlayerPos(playerid,898.9636,-1209.3602,17.9876);
     			return 1;             
			}


if(!strcmp(cmdtext, "/kamion"))
	{ new veh;
	
	veh=GetPlayerVehicleID(playerid);
		

		if(!strcmp(param[1], "szllt") || !strcmp(param[1], "szallit"))
		{
           
				if(IsPlayerInRangeOfPoint(60, playerid, 912.3523,-1231.9344,16.9766))
			 	{
					new tmpcar = GetPlayerVehicleID(playerid);
					if(!IsATruck(tmpcar))
					{
						SendClientMessage(playerid, COLOR_YELLOW, "Szlj bele egy kamionba!");
						return 1;
					}
					
					
					if(IsAPlato(veh))
					{
						SendClientMessage(playerid, COLOR_YELLOW, "Minden rendben! Most menj a kijellt helyre, s ('/kamion lerak')");


						SetPlayerCheckpoint(playerid, 250.2279,1421.1188,10.5859, 3);
						szallit[playerid] = 1;
					}
			 	}
				else
				{
					SendClientMessage(playerid, COLOR_YELLOW, "A HQn kell lenned!");
					SendClientMessage(playerid, COLOR_YELLOW, "A trkped jelzi hova kell menned!");
					SetPlayerCheckpoint(playerid, 912.3523,-1231.9344,16.9766, 3);
					return 1;
				}
			
		}
		else if(!strcmp(param[1], "lerak"))
		{
           
				if(IsPlayerInRangeOfPoint(10, playerid, 250.2279,1421.1188,10.5859))
			 	{
					new tmpcar = GetPlayerVehicleID(playerid);
					if(!IsATruck(tmpcar))
					{
						SendClientMessage(playerid, COLOR_YELLOW, "Nem vagy kamionba!");
						return 1;
					}
					if(szallit[playerid] == 1)
					{
						
						if(IsAPlato(veh))
						{
							SendClientMessage(playerid, COLOR_YELLOW, "Sikeres szllts!");
							SendClientMessage(playerid, COLOR_LIGHTRED, "Fizetsed: 15000FT");
							SendClientMessage(playerid, COLOR_YELLOW, "Most menj vissza, s kezdheted az j szlltst!");
							GivePlayerMoney(playerid, 15000);
							szallit[playerid] = 0;

						}
					}
					else
					{
						SendClientMessage(playerid, COLOR_YELLOW, "Nem is kezdtl el szlltani...");
					}
			 	}
				else
				{
					SendClientMessage(playerid, COLOR_YELLOW, "Menj a kijellt helyre!");
					SetPlayerCheckpoint(playerid, 250.2279,1421.1188,10.5859, 3);
					return 1;
				}
			}
		
		}
		else
			SendClientMessage(playerid, COLOR_YELLOW, "Hasznlata: /kamion [szllt/lerak]");

		return 1;
	}



//----------------------------------------------------------
public OnDialogResponse(playerid, dialogid, response, listitem, inputtext[])
{
    if(dialogid == DIALOG_1)
    {
		if(response == 1)
		{
			switch(listitem)
			{
			    case 0: 
			    {
     			SendClientMessage(playerid, 0xAA3333AA, "Helytelen vlasz Nem mentl t a teszten!");
                
				}
				case 1:
				{
     				ShowPlayerDialog(playerid, DIALOG_2, DIALOG_STYLE_LIST, "Szia! Mi az RK?","Rkosi Kroly\nBosszbl val ls, amit szabad.\nOK nlkli ls\nHallutni bossz, amit tilos","Kivlaszt","Mgse");
				return 1;
               
				}
				case 2:
				{
					SendClientMessage(playerid, 0xAA3333AA, "Helytelen vlasz Nem mentl t a teszten!");
                    	SendClientMessage(playerid, 0xAA3333AA, "Menj a feltlt pontra!");

				}

			}

		}
		else
		{
			SendClientMessage(playerid, 0xEB000FFF, "A Mgsre kattintottl :(");
		}
		return 1;
	}
    if(dialogid == DIALOG_2)
    {
        if(response == 1)
			if(response == 1)
			{
			switch(listitem)
			{
			    case 0: 
			    {
     			SendClientMessage(playerid, 0xAA3333AA, "Helytelen vlasz Nem mentl t a teszten!");

				}
				case 1:
				{
     				ShowPlayerDialog(playerid, DIALOG_1, DIALOG_STYLE_LIST, "Szia! Mi az RK?","Rkosi Kroly\nBosszbl val ls, amit szabad.\nOK nlkli ls","Kivlaszt","Mgse");
				return 1;

				}
				case 2:
				{
					SendClientMessage(playerid, 0xAA3333AA, "Helytelen vlasz Nem mentl t a teszten!");


				}
				case 3:
				{
					SendClientMessage(playerid, 0xAA3333AA, "Helyes vlaszokat adtl j jtkot!");


				}
			}
		}
		else
		{
			SendClientMessage(playerid, 0xEB000FFF, "A Mgsre kattintottl :(");
		}
		return 1;
	}
 if(dialogid == DIALOG_3)
    {
		if(response == 1)
		{
			switch(listitem)
			{
			    case 0: 
			    {
     				static Float: pX, Float: pY, Float: pZ;
					GetPlayerPos( playerid, pX, pY, pZ );
					CreateVehicle( 515, pX + 2.0, pY + 2.0, pZ, 0.0, -1, -1, 1000 );
					SendClientMessage(playerid, 0x38FF06FF, "Kamion elksztve!" );
				}
				case 1:
				{
     				static Float: pX, Float: pY, Float: pZ;
					GetPlayerPos( playerid, pX, pY, pZ );
					CreateVehicle( 435, pX + 2.0, pY + 2.0, pZ, 0.0, -1, -1, 1000 );
					SendClientMessage(playerid, 0x38FF06FF, "Ptkocsi1 elksztve!" );
				}
				case 2:
				{
					static Float: pX, Float: pY, Float: pZ;
					GetPlayerPos( playerid, pX, pY, pZ );
					CreateVehicle( 450, pX + 2.0, pY + 2.0, pZ, 0.0, -1, -1, 1000 );
					SendClientMessage(playerid, 0x38FF06FF, "Ptkocsi2 elksztve!" );
				}
			}
		}
		else
		{
			SendClientMessage(playerid, 0xEB000FFF, "A Mgsre kattintottl :(");
		}
		return 1;
	}


    return 0;
}



//----------------------------------------------------------

public OnPlayerDeath(playerid, killerid, reason)
{
    new playercash;
    
	if(killerid == INVALID_PLAYER_ID) {
        ResetPlayerMoney(playerid);
	} else {
		playercash = GetPlayerMoney(playerid);
		if(playercash > 0)  {
			GivePlayerMoney(killerid, playercash);
			ResetPlayerMoney(playerid);
		}
	}
   	return 1;
}

//----------------------------------------------------------

ClassSel_SetupCharSelection(playerid)
{
   	if(gPlayerCitySelection[playerid] == CITY_LOS_SANTOS) {
		SetPlayerInterior(playerid,11);
		SetPlayerPos(playerid,508.7362,-87.4335,998.9609);
		SetPlayerFacingAngle(playerid,0.0);
    	SetPlayerCameraPos(playerid,508.7362,-83.4335,998.9609);
		SetPlayerCameraLookAt(playerid,508.7362,-87.4335,998.9609);
	}
	else if(gPlayerCitySelection[playerid] == CITY_SAN_FIERRO) {
		SetPlayerInterior(playerid,3);
		SetPlayerPos(playerid,-2673.8381,1399.7424,918.3516);
		SetPlayerFacingAngle(playerid,181.0);
    	SetPlayerCameraPos(playerid,-2673.2776,1394.3859,918.3516);
		SetPlayerCameraLookAt(playerid,-2673.8381,1399.7424,918.3516);
	}

	
}

//----------------------------------------------------------
// Used to init textdraws of city names

ClassSel_InitCityNameText(Text:txtInit)
{
  	TextDrawUseBox(txtInit, 0);
	TextDrawLetterSize(txtInit,1.25,3.0);
	TextDrawFont(txtInit, 0);
	TextDrawSetShadow(txtInit,0);
    TextDrawSetOutline(txtInit,1);
    TextDrawColor(txtInit,0xEEEEEEFF);
    TextDrawBackgroundColor(txtClassSelHelper,0x000000FF);
}

//----------------------------------------------------------

ClassSel_InitTextDraws()
{
    // Init our observer helper text display
	txtLosSantos = TextDrawCreate(10.0, 380.0, "Los Santos");
	ClassSel_InitCityNameText(txtLosSantos);
	txtSanFierro = TextDrawCreate(10.0, 380.0, "San Fierro");
	ClassSel_InitCityNameText(txtSanFierro);
	txtLasVenturas = TextDrawCreate(10.0, 380.0, "Las Venturas");
	ClassSel_InitCityNameText(txtLasVenturas);

    // Init our observer helper text display
	txtClassSelHelper = TextDrawCreate(10.0, 415.0,
	   " Press ~b~~k~~GO_LEFT~ ~w~or ~b~~k~~GO_RIGHT~ ~w~to switch cities.~n~ Press ~r~~k~~PED_FIREWEAPON~ ~w~to select.");
	TextDrawUseBox(txtClassSelHelper, 1);
	TextDrawBoxColor(txtClassSelHelper,0x222222BB);
	TextDrawLetterSize(txtClassSelHelper,0.3,1.0);
	TextDrawTextSize(txtClassSelHelper,400.0,40.0);
	TextDrawFont(txtClassSelHelper, 2);
	TextDrawSetShadow(txtClassSelHelper,0);
    TextDrawSetOutline(txtClassSelHelper,1);
    TextDrawBackgroundColor(txtClassSelHelper,0x000000FF);
    TextDrawColor(txtClassSelHelper,0xFFFFFFFF);
}

//----------------------------------------------------------

ClassSel_SetupSelectedCity(playerid)
{
	if(gPlayerCitySelection[playerid] == -1) {
		gPlayerCitySelection[playerid] = CITY_LOS_SANTOS;
	}
	
	if(gPlayerCitySelection[playerid] == CITY_LOS_SANTOS) {
		SetPlayerInterior(playerid,0);
   		SetPlayerCameraPos(playerid,1630.6136,-2286.0298,110.0);
		SetPlayerCameraLookAt(playerid,1887.6034,-1682.1442,47.6167);
		
		TextDrawShowForPlayer(playerid,txtLosSantos);
		TextDrawHideForPlayer(playerid,txtSanFierro);
		TextDrawHideForPlayer(playerid,txtLasVenturas);
	}
	else if(gPlayerCitySelection[playerid] == CITY_SAN_FIERRO) {
		SetPlayerInterior(playerid,0);
   		SetPlayerCameraPos(playerid,-1300.8754,68.0546,129.4823);
		SetPlayerCameraLookAt(playerid,-1817.9412,769.3878,132.6589);
		
		TextDrawHideForPlayer(playerid,txtLosSantos);
		TextDrawShowForPlayer(playerid,txtSanFierro);
		TextDrawHideForPlayer(playerid,txtLasVenturas);
	}
	else if(gPlayerCitySelection[playerid] == CITY_LAS_VENTURAS) {
		SetPlayerInterior(playerid,0);
   		SetPlayerCameraPos(playerid,1310.6155,1675.9182,110.7390);
		SetPlayerCameraLookAt(playerid,2285.2944,1919.3756,68.2275);
		
		TextDrawHideForPlayer(playerid,txtLosSantos);
		TextDrawHideForPlayer(playerid,txtSanFierro);
		TextDrawShowForPlayer(playerid,txtLasVenturas);
	}
}

//----------------------------------------------------------

ClassSel_SwitchToNextCity(playerid)
{
    gPlayerCitySelection[playerid]++;
	if(gPlayerCitySelection[playerid] > CITY_LAS_VENTURAS) {
	    gPlayerCitySelection[playerid] = CITY_LOS_SANTOS;
	}
	PlayerPlaySound(playerid,1052,0.0,0.0,0.0);
	gPlayerLastCitySelectionTick[playerid] = GetTickCount();
	ClassSel_SetupSelectedCity(playerid);
}

//----------------------------------------------------------

ClassSel_SwitchToPreviousCity(playerid)
{
    gPlayerCitySelection[playerid]--;
	if(gPlayerCitySelection[playerid] < CITY_LOS_SANTOS) {
	    gPlayerCitySelection[playerid] = CITY_LAS_VENTURAS;
	}
	PlayerPlaySound(playerid,1053,0.0,0.0,0.0);
	gPlayerLastCitySelectionTick[playerid] = GetTickCount();
	ClassSel_SetupSelectedCity(playerid);
}

//----------------------------------------------------------

ClassSel_HandleCitySelection(playerid)
{
	new Keys,ud,lr;
    GetPlayerKeys(playerid,Keys,ud,lr);
    
    if(gPlayerCitySelection[playerid] == -1) {
		ClassSel_SwitchToNextCity(playerid);
		return;
	}

	// only allow new selection every ~500 ms
	if( (GetTickCount() - gPlayerLastCitySelectionTick[playerid]) < 500 ) return;
	
	if(Keys & KEY_FIRE) {
	    gPlayerHasCitySelected[playerid] = 1;
	    TextDrawHideForPlayer(playerid,txtClassSelHelper);
		TextDrawHideForPlayer(playerid,txtLosSantos);
		TextDrawHideForPlayer(playerid,txtSanFierro);
		TextDrawHideForPlayer(playerid,txtLasVenturas);
	    TogglePlayerSpectating(playerid,0);
	    return;
	}
	
	if(lr > 0) {
	   ClassSel_SwitchToNextCity(playerid);
	}
	else if(lr < 0) {
	   ClassSel_SwitchToPreviousCity(playerid);
	}
}

//----------------------------------------------------------

public OnPlayerRequestClass(playerid, classid)
{
	if(IsPlayerNPC(playerid)) return 1;

	if(gPlayerHasCitySelected[playerid]) {
		ClassSel_SetupCharSelection(playerid);
		return 1;
	} else {
		if(GetPlayerState(playerid) != PLAYER_STATE_SPECTATING) {
			TogglePlayerSpectating(playerid,1);
    		TextDrawShowForPlayer(playerid, txtClassSelHelper);
    		gPlayerCitySelection[playerid] = -1;
		}
  	}
    
	return 0;
}

//----------------------------------------------------------

public OnGameModeInit()
{
	SetGameModeText("Grand Larceny");
	ShowPlayerMarkers(PLAYER_MARKERS_MODE_GLOBAL);
	ShowNameTags(1);
	SetNameTagDrawDistance(40.0);
	EnableStuntBonusForAll(0);
	DisableInteriorEnterExits();
	SetWeather(2);
	SetWorldTime(11);
	
	//ManualVehicleEngineAndLights();
	//LimitGlobalChatRadius(300.0);
	
	ClassSel_InitTextDraws();

	// Player Class
	AddPlayerClass(1,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(2,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
 	AddPlayerClass(269,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(270,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(271,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(272,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(47,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(48,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(49,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(50,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(51,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(52,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(53,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(54,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(55,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(56,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(57,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(58,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
   	AddPlayerClass(68,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(69,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(70,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(71,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(72,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(73,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(75,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(76,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(78,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(79,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(80,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(81,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(82,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(83,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(84,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(85,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(87,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(88,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(89,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(91,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(92,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(93,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(95,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(96,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(97,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(98,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);
	AddPlayerClass(99,1759.0189,-1898.1260,13.5622,266.4503,-1,-1,-1,-1,-1,-1);


AddStaticVehicle(450,304.7050,878.9153,21.0331,308.9717,0,0); // bnyaI trailer2
AddStaticVehicle(450,302.3265,883.4927,21.0359,308.9171,0,0); // bnya  trailer2 II
AddStaticVehicle(450,299.7791,887.9450,21.0329,309.0157,0,0); // bnya  trailer2 III
AddStaticVehicle(450,297.4230,892.3727,21.0359,308.7314,0,0); // bnya  trailer2 IV
AddStaticVehicle(450,294.6844,897.2885,21.0335,309.0081,0,0); // bnya  trailer2 V
AddStaticVehicle(450,292.1091,902.3562,21.0346,306.0165,0,0); // bnya  trailer2 VI
AddStaticVehicle(450,289.0384,908.1190,21.0270,302.1273,0,0); // bnya  trailer2 VII
AddStaticVehicle(450,-1893.4498,-1701.9182,22.3645,188.8754,0,0); // sf I
AddStaticVehicle(450,-1900.2386,-1702.3577,22.3623,185.4073,0,0); // sf II
AddStaticVehicle(450,-1905.6407,-1703.3735,22.3682,184.7881,0,0); // sf III
AddStaticVehicle(450,-1911.8811,-1704.0237,22.3495,183.0018,0,0); // sf IV
AddStaticVehicle(450,-1918.1505,-1704.3860,22.3688,184.0795,0,0); // sf V

	// SPECIAL
	total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/trains.txt");
	total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/pilots.txt");

   	// LAS VENTURAS
     total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/lv_law.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/lv_airport.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/lv_gen.txt");
    
    // SAN FIERRO
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/sf_law.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/sf_airport.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/sf_gen.txt");
    
    // LOS SANTOS
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/ls_law.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/ls_airport.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/ls_gen_inner.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/ls_gen_outer.txt");
    
    // OTHER AREAS
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/whetstone.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/bone.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/flint.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/tierra.txt");
    total_vehicles_from_files += LoadStaticVehiclesFromFile("vehicles/red_county.txt");

    printf("Total vehicles from files: %d",total_vehicles_from_files);

	return 1;
}

//----------------------------------------------------------

public OnPlayerUpdate(playerid)
{
	if(!IsPlayerConnected(playerid)) return 0;
	
	// changing cities by inputs
	if( !gPlayerHasCitySelected[playerid] &&
	    GetPlayerState(playerid) == PLAYER_STATE_SPECTATING ) {
	    ClassSel_HandleCitySelection(playerid);
	    return 1;
	}
	
	// No weapons in interiors
	if(GetPlayerInterior(playerid) != 0 && GetPlayerWeapon(playerid) != 0) {
	    SetPlayerArmedWeapon(playerid,0); // fists
	    return 0; // no syncing until they change their weapon
	}
	
	// Don't allow minigun
	if(GetPlayerWeapon(playerid) == WEAPON_MINIGUN) {
	    Kick(playerid);
	    return 0;
	}
	
	/* No jetpacks allowed
	if(GetPlayerSpecialAction(playerid) == SPECIAL_ACTION_USEJETPACK) {
	    Kick(playerid);
	    return 0;
	}*/

	/* For testing animations
	if(GetPlayerAnimationIndex(playerid))
	{
	    new animlib[32];
		new animname[32];
		new msg[128+1];
		GetAnimationName(GetPlayerAnimationIndex(playerid),animlib,32,animname,32);
		format(msg, 128, "anim: %s %s", animlib, animname);
		SendClientMessage(playerid, 0xFFFFFFFF, msg);
	} else {
	    SendClientMessage(playerid, 0xFFFFFFFF, "No Anim");
	}*/
	
	return 1;
}

//----------------------------------------------------------
